## glaxnimate 0.5.80+p24.04+vstable+git20251015.1155

=== docs/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.in.yml" "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml")

add_custom_target(
    docs
    COMMAND "PYTHONPATH=${CMAKE_CURRENT_SOURCE_DIR}/extensions/" mkdocs build -f "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml" -d "${CMAKE_CURRENT_BINARY_DIR}/site"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml"
    DEPENDS docs_build_python
)

add_custom_target(
    docs_serve
    COMMAND "PYTHONPATH=${CMAKE_CURRENT_SOURCE_DIR}/extensions/" mkdocs serve -f "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml"
)

if(PYTHON_PIP)
    add_custom_target(
        docs_depends_install
        COMMAND ${PYTHON_PIP} install mkdocs mkdocs-cinder git+https://github.com/mbasaglia/fontawesome-markdown.git@fix babel requests mkdocs-simple-hooks
    )
endif()


add_custom_command(
    OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/docs/img/favicon.png
    COMMAND inkscape ${CMAKE_SOURCE_DIR}/data/logo/favicon.svg -o ${CMAKE_CURRENT_SOURCE_DIR}/docs/img/favicon.png
    DEPENDS ${CMAKE_SOURCE_DIR}/data/logo/favicon.svg
)

add_custom_target(
    docs_build_python
    COMMAND PYTHONPATH=${CMAKE_BINARY_DIR}/bin/python/build/lib ${Python3_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/build_py_doc.py" "${CMAKE_CURRENT_SOURCE_DIR}/docs/python_reference.md" "${CMAKE_CURRENT_BINARY_DIR}/json_reference.md"
    COMMAND cat "${CMAKE_CURRENT_SOURCE_DIR}/json_reference.in.md" "${CMAKE_CURRENT_BINARY_DIR}/json_reference.md" >"${CMAKE_CURRENT_SOURCE_DIR}/docs/json_reference.md"
    BYPRODUCTS "${CMAKE_CURRENT_SOURCE_DIR}/docs/contributing/scripting/python_reference.md" "${CMAKE_CURRENT_SOURCE_DIR}/docs/json_reference.md"
    DEPENDS glaxnimate_python
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/docs/img/favicon.png
)

=== external/QtAppSetup/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause
cmake_minimum_required (VERSION 3.13 FATAL_ERROR)
cmake_policy(SET CMP0076 NEW)

project(QtAppSetup VERSION 0.1.0 LANGUAGES CXX)
set(PROJECT_SLUG QtAppSetup)

# C++
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Qt
find_package(Qt${QT_VERSION_MAJOR}Qml QUIET)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets REQUIRED)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Submodules
add_subdirectory(src)

option(JS_SCRIPTING_ENABLED "Enable JS scripting" OFF)
if(Qt5Qml_FOUND AND JS_SCRIPTING_ENABLED)
    message(STATUS "JS enabled")
    add_subdirectory(src/app/scripting/js/)
endif()


option(PYTHON_SCRIPTING_ENABLED "Enable Python scripting" OFF)
if(PYTHON_SCRIPTING_ENABLED)
    find_package(Python3 COMPONENTS Interpreter Development QUIET)
    if ( Python3_FOUND )
        set(PYTHON_ENABLED ON PARENT_SCOPE)
        message(STATUS "Python3 enabled")
        add_subdirectory(external/pybind11)
        add_subdirectory(src/app/scripting/python)
        target_include_directories (${PROJECT_SLUG} PUBLIC
            ${Python3_INCLUDE_DIRS}
            ${CMAKE_CURRENT_SOURCE_DIR}/external/pybind11/include
        )
    else()
        set(PYTHON_ENABLED OFF PARENT_SCOPE)
    endif()
else()
    set(PYTHON_ENABLED OFF PARENT_SCOPE)
endif()

=== src/android/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set(SOURCES
    android_file_picker.cpp
    android_intent_handler.cpp
    android_style.cpp
    base_dialog.cpp
    better_toolbox_widget.cpp
    document_opener.cpp
    format_selection_dialog.cpp
    help_dialog.cpp
    main.cpp
    main_window.cpp
    main_window.ui
    sticker_pack_builder_dialog.cpp
    sticker_pack_builder_dialog.ui
    telegram_intent.cpp
    timeline_slider.cpp
)

if(NOT ANDROID)
    add_compile_definitions(Q_OS_ANDROID_FAKE)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/external/QtAppSetup/src
    ${CMAKE_SOURCE_DIR}/src/core
    ${CMAKE_SOURCE_DIR}/src/gui
    ${CMAKE_SOURCE_DIR}/external/Qt-Color-Widgets/include
    ${CMAKE_CURRENT_BINARY_DIR}/../gui
)

if (ANDROID)
    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Svg REQUIRED)
    find_package(Qt6 REQUIRED COMPONENTS Core)
endif()

add_executable(${PROJECT_SLUG}_mobile ${SOURCES})
kde_target_enable_exceptions(${PROJECT_SLUG}_mobile PUBLIC)

target_link_libraries(${PROJECT_SLUG}_mobile PUBLIC
    QtAppSetup
    ${LIB_NAME_CORE}
    ${LIB_NAME_GUI}
    QtColorWidgets
    #QtHistoryLineEdit
    Qt${QT_VERSION_MAJOR}::Core
    Qt${QT_VERSION_MAJOR}::Gui
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::UiTools
    Qt${QT_VERSION_MAJOR}::Concurrent
    KF${KF_MAJOR}::I18n
)

if (ANDROID)
    target_link_libraries(${PROJECT_SLUG}_mobile PUBLIC
        Qt${QT_VERSION_MAJOR}::Svg
    )
    target_link_libraries(${PROJECT_SLUG}_mobile PRIVATE Qt6::CorePrivate)
endif()

string(TIMESTAMP VERSION_CODE "%s" UTC)

#install(TARGETS ${PROJECT_SLUG}_mobile ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(TARGETS ${PROJECT_SLUG}_mobile)

if(ANDROID)
    ecm_add_android_apk(${PROJECT_SLUG}_mobile ANDROID_DIR ${CMAKE_CURRENT_SOURCE_DIR}/android)
endif()

# Download Twemoji
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/emoji
    COMMAND rm -r -f /tmp/noto-emoji-main
    COMMAND git clone https://github.com/googlefonts/noto-emoji.git /tmp/noto-emoji-main
    COMMAND mkdir ${CMAKE_CURRENT_BINARY_DIR}/emoji
    COMMAND mv -T /tmp/noto-emoji-main/svg ${CMAKE_CURRENT_BINARY_DIR}/emoji/svg
    COMMAND mv -T /tmp/noto-emoji-main/png/72 ${CMAKE_CURRENT_BINARY_DIR}/emoji/png
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/copy_emoji_flags.py /tmp/noto-emoji-main/third_party/region-flags/svg/ ${CMAKE_CURRENT_BINARY_DIR}/emoji/svg
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/copy_emoji_flags.py /tmp/noto-emoji-main/third_party/region-flags/png/ ${CMAKE_CURRENT_BINARY_DIR}/emoji/png
)
add_custom_target(emoji_images
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/emoji
)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/emoji DESTINATION ${DATA_INSTALL} PATTERN *@* EXCLUDE)
add_dependencies(${PROJECT_SLUG}_mobile emoji_images)
message(STATUS ${DATA_INSTALL}/emoji)

# Lists virtual devices
add_custom_target(
    android_avd_list
    COMMAND "${ANDROID_SDK}/emulator/emulator" -list-avds
)

# Starts a virtual device
# Usage:
#   make android_avd_start DEVICE="device"
# where "device" is from `android_avd_list`
add_custom_target(
    android_avd_start
    COMMAND "${ANDROID_SDK}/emulator/emulator" -avd "$$DEVICE" &
)

# Same as android_avd_start but starts from a clean state
add_custom_target(
    android_avd_clean_start
    COMMAND "${ANDROID_SDK}/emulator/emulator" -avd "$$DEVICE" -no-snapshot &
)


# # Installs (and runs the apk)
# add_custom_target(
#     android_install
#     COMMAND adb install -r $<TARGET_PROPERTY:${PROJECT_SLUG}_mobile,apk>
#     COMMAND adb shell am force-stop ${PACKAGE_NAME}
#     COMMAND adb shell am start -n ${PACKAGE_NAME}/.GlaxnimateActivity -W
#     #DEPENDS ${PROJECT_SLUG}_mobile
# )

# Attaches to the logs of the running app
add_custom_target(
    android_log
    COMMAND adb logcat --pid `adb shell ps -o PID,ARGS | grep -F ${PACKAGE_NAME} | sed -r "'s/^\\s*([0-9]+).*/\\1/'" `
)

=== src/core/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set(SOURCES

app_info.cpp

command/structure_commands.cpp
command/shape_commands.cpp
command/animation_commands.cpp

io/base.cpp
io/binary_stream.cpp
io/utils.cpp
io/glaxnimate/glaxnimate_format.cpp
io/glaxnimate/glaxnimate_importer.cpp
io/glaxnimate/glaxnimate_mime.cpp
io/lottie/cbor_write_json.cpp
io/lottie/lottie_format.cpp
io/lottie/lottie_html_format.cpp
io/lottie/tgs_format.cpp
io/lottie/validation.cpp
io/mime/mime_serializer.cpp
io/raster/raster_format.cpp
io/raster/spritesheet_format.cpp
io/rive/rive_format.cpp
io/rive/rive_html_format.cpp
io/rive/rive_loader.cpp
io/rive/rive_serializer.cpp
io/rive/type_def.cpp
io/rive/type_system.cpp
io/svg/detail.cpp
io/svg/svg_format.cpp
io/svg/svg_parser.cpp
io/svg/svg_renderer.cpp
io/avd/avd_parser.cpp
io/avd/avd_format.cpp
io/avd/avd_renderer.cpp
io/aep/aep_format.cpp
io/aep/aep_loader.cpp
io/aep/string_decoder.cpp
io/aep/gradient_xml.cpp

math/geom.cpp
math/polynomial.cpp
math/ellipse_solver.cpp
math/bezier/bezier.cpp
math/bezier/point.cpp
math/bezier/operations.cpp
math/bezier/cubic_struts.cpp
math/bezier/meta.cpp
math/bezier/bezier_length.cpp

model/document.cpp
model/document_node.cpp
model/object.cpp
model/transform.cpp
model/factory.cpp
model/animation_container.cpp
model/stretchable_time.cpp
model/comp_graph.cpp
model/mask_settings.cpp
model/visitor.cpp
model/custom_font.cpp

model/animation/keyframe_transition.cpp
model/animation/animatable.cpp
model/animation/animatable_path.cpp
model/property/property.cpp
model/property/reference_property.cpp
model/property/option_list_property.cpp

model/assets/assets.cpp
model/assets/brush_style.cpp
model/assets/named_color.cpp
model/assets/bitmap.cpp
model/assets/gradient.cpp
model/assets/asset_base.cpp
model/assets/asset.cpp
model/assets/composition.cpp
model/assets/embedded_font.cpp
model/assets/network_downloader.cpp

model/shapes/shape.cpp
model/shapes/fill.cpp
model/shapes/rect.cpp
model/shapes/group.cpp
model/shapes/ellipse.cpp
model/shapes/path.cpp
model/shapes/stroke.cpp
model/shapes/polystar.cpp
model/shapes/styler.cpp
model/shapes/layer.cpp
model/shapes/image.cpp
model/shapes/precomp_layer.cpp
model/shapes/text.cpp
model/shapes/repeater.cpp
model/shapes/trim.cpp
model/shapes/inflate_deflate.cpp
model/shapes/path_modifier.cpp
model/shapes/round_corners.cpp
model/shapes/offset_path.cpp
model/shapes/zig_zag.cpp

plugin/plugin.cpp
plugin/action.cpp
plugin/io.cpp

utils/gzip.cpp
utils/quantize.cpp
utils/trace.cpp
utils/trace_wrapper.cpp
)

if ( NOT ANDROID )
    list(APPEND SOURCES
        io/video/video_format.cpp
        utils/tar.cpp
    )
    find_package(Libav COMPONENTS codec util format swscale REQUIRED)
    include_directories(${Libav_INCLUDE_DIRS})

    find_package(LibArchive REQUIRED)
    include_directories(${LibArchive_INCLUDE_DIRS})
endif()

find_package(ZLIB REQUIRED)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/application_info_generated.in.hpp
    ${CMAKE_CURRENT_BINARY_DIR}/application_info_generated.hpp
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_SOURCE_DIR}/external/QtAppSetup/src)

if ( GLAXNIMATE_SYSTEM_POTRACE )
    include_directories(${Potrace_INCLUDE_DIRS})
endif()

add_library(${LIB_NAME_CORE} OBJECT ${SOURCES})
kde_target_enable_exceptions(${LIB_NAME_CORE} PUBLIC)
target_link_libraries(${LIB_NAME_CORE} PUBLIC
    QtAppSetup
    ZLIB::ZLIB
    Qt${QT_MAJOR_VERSION}::Xml
    Qt${QT_MAJOR_VERSION}::Network
    ${Potrace_LIBRARIES}
    KF${KF_MAJOR}::CoreAddons
    KF${KF_MAJOR}::Archive
    KF${KF_MAJOR}::I18n
)
set_property(TARGET ${LIB_NAME_CORE} APPEND PROPERTY AUTOMOC_MACRO_NAMES "GLAXNIMATE_OBJECT")
target_include_directories(${LIB_NAME_CORE} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

if ( NOT ANDROID )
    target_link_libraries(${LIB_NAME_CORE} PUBLIC ${Libav_LIBRARIES} ${LibArchive_LIBRARIES} )
endif()

=== src/gui/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set(SOURCES

glaxnimate_app.cpp

emoji/emoji_data.cpp
emoji/emoji_dialog.cpp
emoji/emoji_set.cpp

graphics/handle.cpp
graphics/document_node_graphics_item.cpp
graphics/document_scene.cpp
graphics/transform_graphics_item.cpp
graphics/create_items.cpp
graphics/bezier_item.cpp
graphics/gradient_editor.cpp

item_models/document_node_model.cpp
item_models/property_model_base.cpp
item_models/property_model_single.cpp
item_models/property_model_full.cpp
item_models/gradient_list_model.cpp
item_models/document_model_base.cpp
item_models/comp_filter_model.cpp

settings/clipboard_settings.cpp
settings/icon_settings.cpp
settings/document_templates.cpp
settings/api_credentials.cpp

style/property_delegate.cpp
style/dock_widget_style.cpp
style/scroll_area_event_filter.cpp

tools/base.cpp
tools/freehand.cpp
tools/select_tool.cpp
tools/ellipse_tool.cpp
tools/rectangle_tool.cpp
tools/draw_tool.cpp
tools/edit_tool.cpp
tools/star_tool.cpp
tools/text_tool.cpp
tools/draw_tool_base.cpp

widgets/dialogs/io_status_dialog.cpp
widgets/dialogs/selection_manager.cpp
widgets/dialogs/shape_parent_dialog.cpp
widgets/dialogs/resize_dialog.cpp
widgets/dialogs/timing_dialog.cpp
widgets/dialogs/plugin_ui_dialog.cpp
widgets/dialogs/document_metadata_dialog.cpp
widgets/dialogs/trace_dialog.cpp
widgets/dialogs/clipboard_inspector.cpp
widgets/dialogs/color_quantization_dialog.cpp
widgets/dialogs/export_image_sequence_dialog.cpp
widgets/dialogs/select_shape_dialog.cpp
widgets/dialogs/follow_path_dialog.cpp
widgets/dialogs/stalefiles_dialog.cpp

widgets/docks/layer_view.cpp

widgets/lottiefiles/lottiefiles_search_dialog.cpp
widgets/lottiefiles/search_result.cpp
widgets/lottiefiles/graphql.cpp

widgets/timeline/keyframe_transition_widget.cpp
widgets/timeline/keyframe_editor_widget.cpp
widgets/timeline/frame_controls_widget.cpp
widgets/timeline/timeline_widget.cpp
widgets/timeline/compound_timeline_widget.cpp
widgets/timeline/timeline_items.cpp
widgets/timeline/timeline_treeview.cpp

widgets/tools/shape_tool_widget.cpp
widgets/tools/star_tool_widget.cpp
widgets/tools/color_picker_widget.cpp
widgets/tools/fill_tool_widget.cpp
widgets/tools/text_tool_widget.cpp

widgets/canvas.cpp
widgets/view_transform_widget.cpp
widgets/flow_layout.cpp
widgets/spin2d.cpp
widgets/enum_combo.cpp
widgets/window_message_widget.cpp
widgets/tab_bar/tab_bar_close_button.cpp
widgets/tab_bar/clickable_tab_bar.cpp
widgets/tab_bar/composition_tab_bar.cpp

widgets/settings/plugin_settings_widget.cpp
widgets/settings/plugin_settings_widget.ui

widgets/settings/settings_dialog.cpp

widgets/shape_style/color_selector.cpp
widgets/shape_style/stroke_style_widget.cpp
widgets/shape_style/fill_style_widget.cpp
widgets/shape_style/document_swatch_widget.cpp
widgets/shape_style/gradient_list_widget.cpp

widgets/font/font_model.cpp
widgets/font/font_delegate.cpp
widgets/font/font_preview_widget.cpp
widgets/font/font_style_dialog.cpp
widgets/font/font_style_widget.cpp
widgets/font/google_fonts_model.cpp
widgets/font/google_fonts_widget.cpp
widgets/font/font_size_widget.cpp
widgets/font/external_font_widget.cpp
widgets/font/font_loader.cpp

widgets/menus/animated_property_menu.cpp
)

set(SOURCES_UIS
    widgets/dialogs/io_status_dialog.ui
    widgets/dialogs/shape_parent_dialog.ui
    widgets/dialogs/resize_dialog.ui
    widgets/dialogs/timing_dialog.ui
    widgets/dialogs/document_metadata_dialog.ui
    widgets/dialogs/trace_dialog.ui
    widgets/dialogs/color_quantization_dialog.ui
    widgets/dialogs/export_image_sequence_dialog.ui
    widgets/dialogs/select_shape_dialog.ui
    widgets/dialogs/follow_path_dialog.ui
    widgets/dialogs/stalefiles_dialog.ui

    widgets/lottiefiles/lottiefiles_search_dialog.ui

    widgets/timeline/keyframe_editor_widget.ui
    widgets/timeline/frame_controls_widget.ui
    widgets/timeline/compound_timeline_widget.ui

    widgets/tools/shape_tool_widget.ui
    widgets/tools/color_picker_widget.ui
    widgets/tools/fill_tool_widget.ui

    widgets/view_transform_widget.ui

    widgets/settings/plugin_settings_widget.ui


    widgets/shape_style/color_selector.ui
    widgets/shape_style/stroke_style_widget.ui
    widgets/shape_style/document_swatch_widget.ui
    widgets/shape_style/gradient_list_widget.ui

    widgets/font/font_preview_widget.ui
    widgets/font/font_style_dialog.ui
    widgets/font/font_style_widget.ui
    widgets/font/google_fonts_widget.ui
    widgets/font/font_size_widget.ui
    widgets/font/external_font_widget.ui
)

if ( NOT MOBILE_UI )
    list(APPEND SOURCES
        main.cpp
        cli.cpp

        emoji/emoji_set_dialog.cpp

        tools/color_picker.cpp
        tools/fill_tool.cpp

        widgets/dialogs/about_env_dialog.cpp
        widgets/dialogs/glaxnimate_window.cpp
        widgets/dialogs/startup_dialog.cpp

        widgets/dialogs/gw_impl_document.cpp
        widgets/dialogs/gw_impl_model.cpp
        widgets/dialogs/gw_impl_ui.cpp
        widgets/dialogs/gw_impl_debug.cpp
        widgets/dialogs/gw_impl_selection.cpp

        widgets/docks/aligndock.cpp
        widgets/docks/assetsdock.cpp
        widgets/docks/colorsdock.cpp
        widgets/docks/strokedock.cpp
        widgets/docks/layersdock.cpp
        widgets/docks/propertiesdock.cpp
        widgets/docks/timelinedock.cpp
        widgets/docks/logsdock.cpp
        widgets/docks/timesliderdock.cpp
        widgets/docks/gradientsdock.cpp
        widgets/docks/swatchesdock.cpp
        widgets/docks/snippetsdock.cpp
        widgets/docks/undodock.cpp
        widgets/docks/tooloptionsdock.cpp

        widgets/menus/node_menu.cpp
    )

    list(APPEND SOURCES_UIS
        emoji/emoji_set_dialog.ui

        widgets/dialogs/about_env_dialog.ui
        widgets/dialogs/startup_dialog.ui

        widgets/docks/assets.ui
        widgets/docks/colors.ui
        widgets/docks/stroke.ui
        widgets/docks/layers.ui
        widgets/docks/properties.ui
        widgets/docks/timeline.ui
        widgets/docks/script_console.ui
        widgets/docks/logs.ui
        widgets/docks/time_slider.ui
        widgets/docks/gradients.ui
        widgets/docks/swatches.ui
        widgets/docks/snippets.ui
        widgets/docks/undo.ui
        widgets/docks/tooloptions.ui
    )
endif()

if ( PYTHON_SCRIPTING_ENABLED )
    list(APPEND SOURCES
        gui_python.cpp
        widgets/docks/script_console.cpp
        widgets/docks/snippet_list_widget.cpp
    )

    list(APPEND SOURCES_UIS
        widgets/docks/script_console.ui
        widgets/docks/snippet_list_widget.ui
    )
endif()

configure_file(resources/glaxnimate.in.qrc resources/glaxnimate.qrc)

if(COMMAND qt_add_resources)
    qt_add_resources(SOURCES ${CMAKE_CURRENT_BINARY_DIR}/resources/glaxnimate.qrc)
else()
    qt5_add_resources(SOURCES ${CMAKE_CURRENT_BINARY_DIR}/resources/glaxnimate.qrc)
endif()

set(API_KEY_GOOGLE_FONTS "$ENV{API_KEY_GOOGLE_FONTS}" CACHE STRING "API key for Google Fonts")
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/settings/api_keys.in.hpp
    ${CMAKE_CURRENT_BINARY_DIR}/api_keys.hpp
)

ki18n_wrap_ui(SOURCES_UIS ${SOURCES_UIS})

kconfig_add_kcfg_files(SOURCES GENERATE_MOC glaxnimate_settings.kcfgc)
install(FILES glaxnimate_settings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

include_directories(${CMAKE_SOURCE_DIR}/external/QtAppSetup/src)
include_directories(${CMAKE_SOURCE_DIR}/src/core)
add_library(${LIB_NAME_GUI} OBJECT ${SOURCES} ${SOURCES_UIS})
kde_target_enable_exceptions(${LIB_NAME_GUI} PUBLIC)
target_link_libraries(
    ${LIB_NAME_GUI} PUBLIC
    QtColorWidgets
    ${LIB_NAME_CORE}
    Qt${QT_MAJOR_VERSION}::Widgets
    Qt${QT_MAJOR_VERSION}::UiTools
    Qt${QT_MAJOR_VERSION}::Concurrent
    Qt${QT_MAJOR_VERSION}::Network
    Qt${QT_MAJOR_VERSION}::Svg
    KF${KF_MAJOR}::I18n
    KF${KF_MAJOR}::WidgetsAddons
    KF${KF_MAJOR}::XmlGui
    KF${KF_MAJOR}::Completion
    KF${KF_MAJOR}::IconThemes
    KF${KF_MAJOR}::ConfigCore
)

if(TARGET KF6::BreezeIcons)
    target_link_libraries(${LIB_NAME_GUI} PUBLIC
            KF6::BreezeIcons
    )
    target_compile_definitions(${LIB_NAME_GUI} PRIVATE WITH_BREEZEICONS_LIB)
endif ()

if ( NOT ANDROID )
    target_link_libraries(
        ${LIB_NAME_GUI} PUBLIC
        KF${KF_MAJOR}::Crash
    )
endif()

=== data/lib/python-lottie/Makefile ===
PYTHON=python3
SETUP=setup.py
VERSION_SUF:=$(shell git rev-parse --short HEAD)
VERSION_BASE:=$(shell cat version)
VERSION:=$(VERSION_BASE)$(if $(VERSION_SUF),+dev$(VERSION_SUF),)
SRC:=$(shell find lib -type f -name '*.py') lib/lottie/version.py
OBJECTS:=$(shell find lib/lottie/objects -type f -name '*.py')
SCRIPTS:=$(wildcard bin/*.py)
VERSION_IN_FILE=$(shell cat .version_full)
$(if $(VERSION_IN_FILE) != $(VERSION), $(shell echo '$(VERSION)' > .version_full))
PACKAGE_NAME:=$(shell $(PYTHON) $(SETUP) --name)

.SUFFIXES:

.PHONY: all upload docs clean_pyc pypi blender inkscape release dist distclean synfig version next_version lint


all: pypi blender inkscape synfig

dist: all

distclean:
	rm dist/*

release:
	make all upload VERSION_SUF=

dist/$(PACKAGE_NAME)-$(VERSION).tar.gz: $(SETUP) $(SRC) $(SCRIPTS)
	$(PYTHON) $(SETUP) sdist

upload: dist/$(PACKAGE_NAME)-$(VERSION).tar.gz
	$(PYTHON) -m twine upload dist/$(PACKAGE_NAME)-$(VERSION).tar.gz

docs: docs/html/index.html

docs/Doxyfile: docs/Doxyfile.in setup.py
	m4 -P -DM4_NAME="python-$(PACKAGE_NAME)" -DM4_VERSION="$(VERSION)" -DM4_DESCRIPTION="$(shell $(PYTHON) $(SETUP) --description)" $< >$@

docs/dox/lottie.dox: docs/dox_lottie.py
docs/dox/lottie.dox: $(OBJECTS)
	$(PYTHON) docs/dox_lottie.py

docs/dox/examples/%.dox: examples/%.py docs/dox_examples.py
	$(PYTHON) docs/dox_examples.py $*

docs/dox/downloads.dox: docs/dox_download.py setup.py
	$(PYTHON) docs/dox_download.py --version-base $(VERSION_BASE) --version-suf $(VERSION_SUF) --version $(VERSION)

docs/html/index.html: docs/Doxyfile
docs/html/index.html: $(foreach file,$(wildcard examples/*.py), docs/dox/examples/$(basename $(notdir $(file))).dox)
docs/html/index.html: docs/dox/lottie.dox
docs/html/index.html: docs/dox/scripts.dox
docs/html/index.html: docs/dox/downloads.dox
docs/html/index.html: $(SRC)
	doxygen docs/Doxyfile

dist/$(PACKAGE_NAME)-inkscape-$(VERSION).zip: $(wildcard addons/inkscape/*)
	zip --junk-paths $@ $^
	echo "Upload at https://inkscape.org/~mattia.basaglia/%E2%98%85tgslottie-importexport"

docs/dox/scripts.dox: docs/dox_scripts.py
docs/dox/scripts.dox: $(SCRIPTS)
	$(PYTHON) docs/dox_scripts.py

clean_pyc:
	find lib -name '*.pyc' -delete
	find lib -name '__pycache__' -exec rm -rf {} \;


dist/$(PACKAGE_NAME)-blender-$(VERSION).zip: $(wildcard addons/blender/lottie_io/*.py) $(SRC)
	addons/update_version.py
	cd addons/blender && find -L -name '*.py' | xargs zip --filesync ../../$@

dist/$(PACKAGE_NAME)-synfig-$(VERSION).zip: $(wildcard addons/synfig/*) $(SRC)
	cd addons/synfig && find -L -type f -not -name "*.pyc" | xargs zip --filesync ../../$@

pypi: dist/$(PACKAGE_NAME)-$(VERSION).tar.gz

inkscape: dist/$(PACKAGE_NAME)-inkscape-$(VERSION).zip

blender: dist/$(PACKAGE_NAME)-blender-$(VERSION).zip

synfig: dist/$(PACKAGE_NAME)-synfig-$(VERSION).zip

lib/lottie/version.py: .version_full
	echo '__version__ = "$(VERSION)"' > $@

version: lib/lottie/version.py
	$(PYTHON) $(SETUP) --version

next_version: VERSION = $(shell echo 'x = "$(VERSION_BASE)".split("."); x[-1] = str(int(x[-1]) + 1); print(".".join(x))' | python)
next_version:
	echo $(VERSION) >version

lint:
	flake8 lib/$(PACKAGE_NAME)

=== data/lib/python-lottie/requirements.txt ===
# Tracing
# pypotrace>=0.2 the pypotrace is bugged, install it separately
# scipy

# Raster support
pillow
cairosvg

# Tex/Font
fonttools
grapheme

# Video exporters
opencv-python
numpy

# GUI scripts
PyQt5
QScintilla

# Testing
coverage
flake8

=== external/Qt-Color-Widgets/gallery/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2013-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set (QT_SUPPORTED_VERSIONS 5)


set(SCREENSHOT_SOURCES screenshot.cpp)
set(SCREENSHOT_BINARY screenshot_bin)

add_executable(${SCREENSHOT_BINARY} EXCLUDE_FROM_ALL ${SCREENSHOT_SOURCES})

target_link_libraries(
    ${SCREENSHOT_BINARY}
    PRIVATE
    ${COLOR_WIDGETS_LIBRARY}
    Qt${QT_VERSION_MAJOR}::Widgets
)

add_custom_target(gallery
    COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${SCREENSHOT_BINARY}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${SCREENSHOT_BINARY}
)

=== external/QtAppSetup/src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(SOURCES
app/application.cpp
app/settings/settings_group.cpp
app/settings/settings.cpp
app/scripting/script_engine.cpp
app/log/logger.cpp
app/log/log_model.cpp
app/cli.cpp
)

add_library(${PROJECT_SLUG} OBJECT ${SOURCES})
target_link_libraries(${PROJECT_SLUG} PUBLIC Qt${QT_VERSION_MAJOR}::Widgets QtColorWidgets)
target_include_directories(${PROJECT_SLUG} PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)
kde_target_enable_exceptions(${PROJECT_SLUG} PUBLIC)

=== external/Qt-Color-Widgets/include/QtColorWidgets/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2013-2023 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

set (HEADERS
abstract_widget_list.hpp
bound_color_selector.hpp
color_2d_slider.hpp
color_delegate.hpp
color_dialog.hpp
color_line_edit.hpp
color_list_widget.hpp
color_names.hpp
color_palette.hpp
color_palette_model.hpp
color_palette_widget.hpp
color_preview.hpp
color_selector.hpp
color_wheel.hpp
colorwidgets_global.hpp
gradient_slider.hpp
hue_slider.hpp
swatch.hpp
gradient_editor.hpp
harmony_color_wheel.hpp
gradient_list_model.hpp
gradient_delegate.hpp
)

file(RELATIVE_PATH
  PREFIX
  ${PROJECT_SOURCE_DIR}
  ${CMAKE_CURRENT_LIST_DIR})


foreach (HEADER IN LISTS HEADERS)
  target_sources (${TARGET_NAME}
    PRIVATE
    $<INSTALL_INTERFACE:${PREFIX}/${HEADER}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/${HEADER}>)
endforeach (HEADER IN HEADERS)

## glaxnimate 0.5.80

=== debian/changelog ===
glaxnimate (0.5.80-0zneon+24.04+noble+release+build2) noble; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Fri, 21 Feb 2025 22:38:42 +0000

glaxnimate (0.5.80-0neon) noble; urgency=low

  [ Scarlett Moore ]
  * Initial release. Closes: #nnnn
    <nnnn is the bug number of your ITP>

  [ Carlos De Maine ]
  * New release

 -- Carlos De Maine <carlosdemaine@gmail.com>  Sat, 22 Feb 2025 08:31:28 +1000

=== debian/control ===
Source: glaxnimate
Section: unknown
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               extra-cmake-modules,
               git,
               libarchive-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libkf5archive-dev,
               libkf5completion-dev,
               libkf5coreaddons-dev,
               libkf5crash-dev,
               libkf5widgetsaddons-dev,
               libkf5xmlgui-dev,
               libpotrace-dev,
               libpython3-dev,
               libqt5svg5-dev,
               libswscale-dev,
               pkg-kde-tools,
               pybind11-dev,
               python3-pybind11,
               qt5-image-formats-plugins,
               qtbase5-dev,
               qttools5-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://glaxnimate.mattbas.org
Vcs-Git: https://invent.kde.org/neon/neon-packaging/glaxnimate.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/glaxnimate
Maintainer: Neon CI <neon@kde.org>

Package: glaxnimate
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Simple vector animation program.
 This Debian binary package was auto-generated by the
 debmake(1) command provided by the debmake package.

=== debian/rules ===
#!/usr/bin/make -f
# You must remove unused comment lines for the released package.
#export DH_VERBOSE = 1
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with kde

override_dh_auto_configure:
	dh_auto_configure -- \
	-DINSTALL_TRANSLATIONS=OFF 
#	-DMOBILE_UI=ON

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/archive\/(\d\S+)\/glaxnimate.*\.tar\.gz/glaxnimate-$1\.tar\.gz/g \
  https://gitlab.com/mattbas/glaxnimate/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.gz.*

## glaxnimate 0.5.80+p24.04+vstable+git20250925.1428

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20250925.1428-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 25 Sep 2025 14:28:15 +0000

## glaxnimate 0.5.80+p24.04+vstable+git20250928.0636

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20250928.0636-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 28 Sep 2025 06:36:15 +0000

## glaxnimate 0.5.80+p24.04+vstable+git20251011.2359

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20251011.2359-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 11 Oct 2025 23:59:52 +0000

## glaxnimate 0.5.80+p24.04+vstable+git20251015.1155

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20251015.1155-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 11:55:27 +0000

=== debian/control ===
Source: glaxnimate
Section: unknown
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               kf6-extra-cmake-modules,
               kf6-karchive-dev,
               kf6-kcompletion-dev,
               kf6-kcoreaddons-dev,
               kf6-kcrash-dev,
               kf6-ki18n-dev,
               kf6-kwidgetsaddons-dev,
               kf6-kxmlgui-dev,
               libarchive-dev,
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libpotrace-dev,
               libpython3-dev,
               libswscale-dev,
               pkg-kde-tools-neon,
               pybind11-dev,
               python3-pybind11,
               qt6-base-dev,
               qt6-imageformats-dev,
               qt6-svg-dev,
               qt6-tools-dev,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://glaxnimate.mattbas.org
Vcs-Git: https://invent.kde.org/neon/neon-packaging/glaxnimate.git
Vcs-Browser: https://invent.kde.org/neon/neon-packaging/glaxnimate
Maintainer: Neon CI <neon@kde.org>

Package: glaxnimate
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Simple vector animation program.
 This Debian binary package was auto-generated by the
 debmake(1) command provided by the debmake package.

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# # SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_WITH_QT6=ON
#	-DMOBILE_UI=ON

## glaxnimate 0.5.80+p24.04+vstable+git20251021.0656

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20251021.0656-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 06:56:16 +0000

## glaxnimate 0.5.80+p24.04+vstable+git20251231.0108

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20251231.0108-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 31 Dec 2025 01:08:24 +0000

## glaxnimate 0.5.80+p24.04+vstable+git20260107.0718

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20260107.0718-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 07 Jan 2026 07:18:30 +0000

## glaxnimate 0.5.80+p24.04+vstable+git20260131.0300

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20260131.0300-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sat, 31 Jan 2026 03:00:52 +0000

## glaxnimate 0.5.80+p24.04+vstable+git20260202.1142

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20260202.1142-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 02 Feb 2026 11:42:54 +0000

=== debian/rules ===
--- 
+++ 
@@ -7,5 +7,6 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-	-DBUILD_WITH_QT6=ON
+	-DBUILD_WITH_QT6=ON \
+	-DVERSION_SUFFIX=NEON
 #	-DMOBILE_UI=ON

## glaxnimate 0.5.80+p24.04+vstable+git20260204.0049

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2025 Mattia Basaglia <dev@dragon.best>
# SPDX-License-Identifier: BSD-2-Clause

cmake_minimum_required (VERSION 3.16 FATAL_ERROR)
# cmake_policy(SET CMP0076 NEW)
cmake_policy(SET CMP0077 NEW)
cmake_policy(SET CMP0153 NEW)


project(Glaxnimate VERSION 0.5.80 LANGUAGES CXX)
include(FeatureSummary)

set(PROJECT_SLUG "glaxnimate")
set(LIB_NAME_CORE "${PROJECT_SLUG}_core")
set(LIB_NAME_GUI "${PROJECT_SLUG}_gui")
set(LIB_NAME_PYTHON "${PROJECT_SLUG}_python_lib")
set(LIB_NAME_DESKTOP "${PROJECT_SLUG}_desktop")
set(DATA_INSTALL "share/${PROJECT_SLUG}/${PROJECT_SLUG}")
set(PROJECT_ID "org.kde.glaxnimate")

set(PROJECT_HOMEPAGE_URL "https://glaxnimate.org/")
set(URL_DOCS "https://docs.glaxnimate.org/")
set(URL_ISSUES "https://bugs.kde.org/enter_bug.cgi?product=glaxnimate")
set(URL_DONATE "https://glaxnimate.org/donate/")

# You can use it to change the url used by `make docs`
set(DOCS_SITE_URL ${URL_DOCS} CACHE STRING "")
set(DOCS_REPO_URL "https://gitlab.com/mattbas/glaxnimate")
set(DOCS_CHAT_URL "https://t.me/Glaxnimate")

set(PROJECT_DESCRIPTION "Simple vector animation program")
set(PROJECT_MANINTAINER_NAME "Mattia Basaglia")
set(PROJECT_MANINTAINER_EMAIL "glanimate@mattbas.org")
set(PROJECT_MANINTAINER "${PROJECT_MANINTAINER_NAME} <${PROJECT_MANINTAINER_EMAIL}>")

option(MOBILE_UI "Build the mobile user interface" OFF)

add_definitions(-DTRANSLATION_DOMAIN=\"glaxnimate\")

if (ANDROID)
    set(MOBILE_UI ON)
endif()

if(MOBILE_UI)
    message(STATUS "Using mobile UI")
    add_compile_definitions(MOBILE_UI)
else()
    message(STATUS "Using desktop UI")
endif()

# CMake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(misc)

# C++
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Git
set(VERSION_NAKED ${PROJECT_VERSION})
set(VERSION_SUFFIX "-git-" CACHE STRING "")

if (VERSION_SUFFIX STREQUAL "-git-" AND EXISTS ${CMAKE_SOURCE_DIR}/.git)
    # Probably a Git workspace; determine the revision.
    find_package(Git QUIET)
    if(GIT_FOUND)
        execute_process(
            COMMAND ${GIT_EXECUTABLE} log "-n" 1 "--pretty=format:%h"
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE GIT_REVISION
        )
        message(STATUS "Git revision: ${GIT_REVISION}")
        set(PROJECT_VERSION "${PROJECT_VERSION}-git-${GIT_REVISION}")
    else()
        message(STATUS "Git revision could not be determined")
    endif()
elseif(VERSION_SUFFIX MATCHES "^\\..*")
    set(PROJECT_VERSION "${PROJECT_VERSION}${VERSION_SUFFIX}")
elseif(NOT VERSION_SUFFIX STREQUAL "")
    set(PROJECT_VERSION "${PROJECT_VERSION}+${VERSION_SUFFIX}")
endif()

message(STATUS "Building ${PROJECT_NAME} ${PROJECT_VERSION}")

# Snapcraft stuff here because we don't care if cmake fails on CI
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/deploy/snapcraft.in.yaml"
    "${CMAKE_CURRENT_BINARY_DIR}/snapcraft.yaml"
)
option(SNAP_IS_SUCH_A_PAIN "" OFF)
if ( SNAP_IS_SUCH_A_PAIN  )
    return()
endif()

# Fucking Windows being shit
if ( WIN32 AND MinGW )
    # Without this shit it gives a bunch of errors like this:
    # * referenced in section `.rdata' of * defined in discarded section `.gnu.linkonce.*`
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-lto")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fno-lto")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fno-lto")
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
    set(CMAKE_ENABLE_EXPORTS TRUE)
endif()


# Python
if ( NOT MOBILE_UI )
    set(PYTHON_SCRIPTING_ENABLED ON)
else()
    set(PYTHON_SCRIPTING_ENABLED OFF)
endif()

if ( PYTHON_SCRIPTING_ENABLED )
    find_program(PYTHON_PIP pip3)
    if(NOT PYTHON_PIP)
        find_program(PYTHON_PIP pip)
    endif()

    find_package(Python3 COMPONENTS Interpreter Development REQUIRED)
    message(STATUS ${Python3_EXECUTABLE})

    set(PYBIND11_FINDPYTHON ON)
else()
    message(STATUS "Python Disabled")
endif()

# QT_MAJOR_VERSION is the common name in KDE apps and infrastructure.
# BUILD_WITH_QT6 is another thing on KDE infrastructure.
# However some third-party submodules use QT_VERSION_MAJOR so we need to set that too.
if (NOT DEFINED QT_MAJOR_VERSION)
    if(BUILD_WITH_QT6)
        set(QT_MAJOR_VERSION 6)
    else()
        set(QT_MAJOR_VERSION 5)
    endif()
endif()
set(QT_VERSION_MAJOR ${QT_MAJOR_VERSION})

# Qt
find_package(Qt${QT_MAJOR_VERSION} COMPONENTS Core Widgets Xml UiTools Concurrent Network Svg REQUIRED)
message(STATUS "Using Qt ${QT_MAJOR_VERSION}")

# KF
set(KF_DEP_VERSION "5.92.0")
find_package(ECM ${KF_DEP_VERSION} REQUIRED CONFIG)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_MODULE_PATH})
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings)
if (QT_MAJOR_VERSION STREQUAL "6")
    include(ECMAddAndroidApk)
endif()
include(ECMAddAppIcon)

# TODO: The following definitons should be enabled
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
)

if (NOT DEFINED KF_MAJOR)
  set(KF_MAJOR ${QT_MAJOR_VERSION})
endif()

if (KF_MAJOR STREQUAL "6")
  set(KF_DEP_VERSION "5.240.0")
endif()

find_package(KF6BreezeIcons ${KF_DEP_VERSION} QUIET)

find_package(KF${KF_MAJOR} ${KF_DEP_VERSION}
    REQUIRED COMPONENTS
    I18n
    CoreAddons
    WidgetsAddons
    XmlGui
    Archive
    Completion
    IconThemes
    Config
)
if ( NOT ANDROID )
    find_package(KF${KF_MAJOR} ${KF_DEP_VERSION}
        REQUIRED COMPONENTS
        Crash
    )
endif()


set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Potrace
option(GLAXNIMATE_SYSTEM_POTRACE "Use the system potrace libarary" ON)
if (NOT GLAXNIMATE_SYSTEM_POTRACE)
    message(STATUS "Using bundled potrace")
    set(CMAKE_C_COMPILE_OBJECT ${CMAKE_CXX_COMPILE_OBJECT})
    add_subdirectory(external/potrace/)
    set(Potrace_LIBRARIES potrace)
    include_directories(external/potrace/src/)
else()
    find_package(Potrace REQUIRED)
endif()

# Debug flags
if(CMAKE_BUILD_TYPE STREQUAL "")
    set(CMAKE_BUILD_TYPE "Debug")
endif()
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -pedantic -Wextra")
message(STATUS "${CMAKE_BUILD_TYPE} build")

# sub projects and stuff

SET(BUILD_STATIC_LIBS ON CACHE BOOL "")
SET(BUILD_SHARED_LIBS OFF CACHE BOOL "")
add_definitions(-DQTCOLORWIDGETS_STATICALLY_LINKED)

add_subdirectory(external/QtAppSetup)

add_subdirectory(data ${DATA_INSTALL})

add_subdirectory(src bin)

set(QTCOLORWIDGETS_DESIGNER_PLUGIN ON)
set(QTCOLORWIDGETS_BUILD_STATIC_LIBS ON)
add_subdirectory(external/Qt-Color-Widgets EXCLUDE_FROM_ALL)

set(ALL_SOURCE_DIRECTORIES src)
find_sources(ALL_SOURCES *.cpp *.hpp)

if(BUILD_TESTING)
    find_package(Qt${QT_MAJOR_VERSION}Test REQUIRED)
    message(STATUS "Tests enabled")
    add_subdirectory(test)
endif()

add_subdirectory(docs)

# Doxygen

set(DOXYGEN_FOUND ON)
find_package(Doxygen QUIET)
if(DOXYGEN_FOUND)
    create_doxygen_target(doxygen)
endif(DOXYGEN_FOUND)

# Release

add_custom_target(
    release_0
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_0.sh ${CMAKE_CURRENT_BINARY_DIR}/CMakeCache.txt
)
add_custom_target(
    release_1
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_1.sh ${CMAKE_CURRENT_BINARY_DIR}/CMakeCache.txt
)
add_custom_target(
    release_check
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/deploy/release_check.py ${VERSION_NAKED}
)

# Misc files
if (ANDROID)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/android/android/version.gradle.in ${CMAKE_BINARY_DIR}/version.gradle)
endif()
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/deploy/org.kde.glaxnimate.metainfo.xml DESTINATION share/metainfo)

ki18n_install(po)
file(CREATE_LINK ${CMAKE_CURRENT_BINARY_DIR}/locale ${CMAKE_CURRENT_BINARY_DIR}/share/locale SYMBOLIC)

# Packaging
# -- see https://gitlab.kitware.com/cmake/community/-/wikis/doc/cpack/PackageGenerators
set(CPACK_PACKAGE_CONTACT ${PROJECT_MANINTAINER})
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${PROJECT_DESCRIPTION})

execute_process(COMMAND dpkg-architecture -qDEB_BUILD_ARCH OUTPUT_VARIABLE CPACK_DEBIAN_PACKAGE_ARCHITECTURE ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libqt5xml5 (>= 5.10.0), libqt5widgets5 (>= 5.10.0), libpython3.10 (>= 3.10.0), zlib1g (>= 1:1.2.11), libpotrace0 (>= 1.16-2), libavformat58, libswscale5, qt5-image-formats-plugins, libarchive13")
set(CPACK_DEBIAN_PACKAGE_SECTION "graphics")
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE ${PROJECT_HOMEPAGE_URL})

set(CPACK_BUNDLE_NAME ${PROJECT_NAME})

set(CPACK_BUNDLE_ICON "${CMAKE_CURRENT_BINARY_DIR}/glaxnimate.icns")

include(CPack)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
+# SPDX-FileCopyrightText: 2019-2025 Mattia Basaglia <dev@dragon.best>
 # SPDX-License-Identifier: BSD-2-Clause
 
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.in.yml" "${CMAKE_CURRENT_SOURCE_DIR}/mkdocs.yml")

=== test/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2025 Mattia Basaglia <dev@dragon.best>
# SPDX-FileCopyrightText: 2023 Julius Künzel <jk.kdedev@smartlab.uber.space>
# SPDX-License-Identifier: BSD-2-Clause

include(ECMAddTests)

include_directories(
    ${CMAKE_SOURCE_DIR}/src
    # ${CMAKE_SOURCE_DIR}/external/QtAppSetup/src
    ${CMAKE_SOURCE_DIR}/src/core
)

set(TESTS_LINK_LIBS
    Qt${QT_MAJOR_VERSION}::Test
    Qt${QT_MAJOR_VERSION}::Widgets
    KF${KF_MAJOR}::I18n
    QtColorWidgets
    QtAppSetup
)

# Single source file tests, linking only to default libs

ecm_add_tests(
    test_bezier_solver.cpp
    test_riff.cpp
    LINK_LIBRARIES ${TESTS_LINK_LIBS}
)

# Single source file tests, linking to core lib additionally

ecm_add_tests(
    test_property.cpp
    test_trim_path.cpp
    test_trace.cpp
    test_aep_gradient_xml.cpp
    LINK_LIBRARIES ${TESTS_LINK_LIBS} ${LIB_NAME_CORE}
)

# Multi source files tests

ecm_add_test(
    test_bezier_length.cpp
    ../src/core/math/bezier/bezier.cpp
    ../src/core/math/bezier/point.cpp
    ../src/core/math/bezier/bezier_length.cpp
    TEST_NAME test_bezier_length
    LINK_LIBRARIES ${TESTS_LINK_LIBS}
)

ecm_add_test(
    test_keyframe_transition.cpp
    ../src/core/model/animation/keyframe_transition.cpp
    ../src/core/math/polynomial.cpp
    TEST_NAME test_keyframe_transition
    LINK_LIBRARIES ${TESTS_LINK_LIBS}
)

ecm_add_test(
    test_cos_parser.cpp
    ../src/core/io/aep/string_decoder.cpp
    TEST_NAME test_cos_parser
    LINK_LIBRARIES ${TESTS_LINK_LIBS}
)

=== src/android/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
+# SPDX-FileCopyrightText: 2019-2025 Mattia Basaglia <dev@dragon.best>
 # SPDX-License-Identifier: BSD-2-Clause
 
 set(SOURCES

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
+# SPDX-FileCopyrightText: 2019-2025 Mattia Basaglia <dev@dragon.best>
 # SPDX-License-Identifier: BSD-2-Clause
 
 set(SOURCES

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
+# SPDX-FileCopyrightText: 2019-2025 Mattia Basaglia <dev@dragon.best>
 # SPDX-License-Identifier: BSD-2-Clause
 
 set(SOURCES

=== external/QtAppSetup/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2019-2023 Mattia Basaglia <dev@dragon.best>
+# SPDX-FileCopyrightText: 2019-2025 Mattia Basaglia <dev@dragon.best>
 #
 # SPDX-License-Identifier: GPL-3.0-or-later

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vstable+git20260204.0049-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 04 Feb 2026 00:49:39 +0000

## glaxnimate 0.5.80+p24.04+vunstable+git20260107.0953

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vunstable+git20260107.0953-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 07 Jan 2026 09:54:01 +0000

## glaxnimate 0.5.80+p24.04+vunstable+git20260201.0617

=== debian/changelog ===
glaxnimate (0.5.80+p24.04+vunstable+git20260201.0617-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Sun, 01 Feb 2026 06:17:18 +0000
